<template>
<span>
  <span class="currency" v-if="value!==null">
    <span class="symbol" v-html="symbol"></span>
    <span class="amount">{{ amount | trim(trim)  }}<span v-if="!trim" class="rest">{{ restOfAmount }}</span></span>
    <span class="ticker" v-if="!symbol && ticker"> {{ ticker.toUpperCase() }}</span>
  </span>
  <span v-else-if="currency!==null">
      <span class="symbol" v-html="symbol"></span>
      <span class="rest">{{ restOfAmount | trim }}</span>
      <span class="ticker" v-if="!symbol && ticker"> {{ ticker.toUpperCase() }}</span>
  </span>
  <span v-else>
    {{ $t('general.label.zero') }}
  </span>
</span>
</template>
<script>

import { FIAT } from '../lib/supported-fiat.js';

const trimDecimalZeroes = (value = '0') => String(value).replace(/(\.\d*?)0+$/, (m, a) => a).replace(/\.$/, '');
const leftPad = (string, length, padding = ' ') => padding.repeat(length - string.length) + string;

export default {
  props: {
    'value': { },
    'currency': {
      required: false,
    },
    'trim': {
      type: Boolean,
      default: false,
    },
    'decimal': {
      type: Number,
      default: 0,
    },
    precision: {
      type: Number,
    },
    inLocal: {
      type: Boolean,
      default: false,
    },
    commas: {
      type: Boolean,
      default: true,
    },
  },
  filters: {
    trim: function(value, trim) {
      return trim ? trimDecimalZeroes(value) : value;
    },
  },
  computed: {
    scale() {
      return this.scaleFor(this.currencyObject);
    },
    symbol() {
      if(!this.value || !this.value.symbol) {
        return this.currencyMeta().symbol || '';
      }
      return this.value.symbol;
    },
    ticker() {
      var symbol = this.symbol;
      var value = this.value;
      var ticker = this.currencyMeta().currency;

      if(symbol && ticker && this.inLocal) return '';

      return ticker || '';
    },
    currencyObject() {
      let value = this.value;
      if(typeof value === 'object') return value;
      if(typeof value === 'number') value = String(value);
      if(typeof value === 'string' && this.currency) return this.stringToCurrency(value);
      return null;
    },
    formattedAmount() {
      return this.currencyObject ? this.currencyToString(this.currencyObject) : this.value;
    },
    amount() {
      if (!this.value) return;
      if (!this.currencyObject) return this.formattedAmount;
      const { beforeDot, afterDot } = this.amountParts(this.currencyObject);
      const scale = this.decimal || this.scale;
      if (afterDot && afterDot.length > scale) {
        // if the number needs to be rounded
        // TODO: Refactor out this dangerous float conversion.  Consider values which truncate or round when floated.
        return parseFloat(this.formattedAmount.replace(",","")).toFixed(this.precision || scale);
      }
      return typeof this.value !== "object" ? this.value : this.formattedAmount;
    },

    restOfAmount() {
      var value = this.value;
      var scale = this.scaleFor(this.currency);
      
      if(value && (typeof value == 'object' || typeof value == 'string')) return '';
      var amount;


      if(this.decimal < scale) {
        scale = this.decimal;
      }

      if(typeof value == 'number')
        amount = value.toFixed(scale);
      else
        amount = value || '';

      // '0' if there's nothing:
      var p = amount.length == 0 ? '0' : '';

      // add a dot if there isn't one:
      var dot = amount.indexOf('.');
      if(dot == -1) {
        if(!amount) return '0';
        else return '';
      }

      var s = (dot==-1?'.':'');
      if(dot == -1) { dot = amount.length; }

      // and pad the resulting thing so it has as many zeroes as desired for the currency

      var r = scale - ((amount+s).length - dot) + 1;
      if(r < 0) return s;
      return p + s + '0'.repeat(r);
    },

  },
  methods: {
    currencyMeta(c) {
      c = (typeof c == "string" && c) || (this.value && this.value.currency) || (this.currency && this.currency.currency);
      if(!c && typeof this.currency === "string") c = this.currency;
      
      let meta = {
        currency: c,
      };
      if(c && typeof c == 'object') meta = c;
      if (meta.currency) meta.currency = meta.currency.toUpperCase();
      
      return FIAT.find(fiat => fiat.currency === meta.currency) || meta;
    },
    scaleFor(currency) {
      if(currency) currency = this.currencyMeta(currency);
      if (typeof currency === 'object') {
        if(currency === null) return 0;
        if('scale' in currency) return currency.scale;
        if('precision' in currency) return currency.precision;
        if('denominator' in currency) return currency.denominator.length-1;
      }

      // default case is ETH tokens, because they're going to be the easiest to add in future:
      return 18;
    },
    amountParts({ numerator, denominator, scale: precision }) {
      if(!numerator || !denominator) return {};
      numerator = this.toNumberString(numerator);
      denominator = this.toNumberString(denominator);
      const scale = denominator.length - 1;
      const dot = Math.max(0, numerator.length - scale);
      let beforeDot = numerator.substring(0, dot) || '0';
      if(this.commas) beforeDot = this.addDelimiter(beforeDot);
      const afterDot = leftPad(numerator.substring(dot), scale,'0');
      const afterDotWithPrecision = afterDot.substring(0, this.precision || precision);
      return {
        beforeDot,
        afterDot: afterDotWithPrecision
      };
    },
    currencyToString(value) {
      if(!value || !value.numerator) return '0';

      const denominator = this.toNumberString(value.denominator);
      const scale = this.scaleFor(value);
      const { numerator, sign } = this.extractSign(value.numerator);
      const { beforeDot, afterDot } = this.amountParts({ numerator, denominator, scale });

      if(scale != 0) {
        return `${sign}${beforeDot}.${afterDot}`;
      }

      return `${sign}${ beforeDot }`;
    },
    stringToCurrency(string) {
      const currency = this.currencyMeta();

      if(typeof string == 'number') {
        string = String(string);
      }

      if(!string) {
        string = '0';
      }

      if(typeof string == 'object') debugger;

      var scale = this.scaleFor(currency);

      var dot = string.indexOf('.');
      if (dot == -1) dot = string.length;

      var beforeDot = string.substring(0, dot);
      var afterDot = string.substring(dot + 1);

      // limit afterDot:
      afterDot = afterDot.substring(0,scale);
      afterDot = afterDot + '0'.repeat(scale - afterDot.length);

      var numerator = beforeDot + afterDot;
      var denominator = '1'+'0'.repeat(scale);
      // strip leading zeroes:
      numerator = numerator.match(/^0*(.*)$/)[1] || "0";

      return Object.assign({  }, currency, { numerator, denominator, scale });
    },
    toNumberString(string=0) {
      var number = String(string);
      var exp;
      if((exp = number.match(/^(.+?)(?:\.(.+?))?[eE]\+?(\d+)$/))) {
        var whole = exp[1];
        var fractional = exp[2] || '';
        var digits = whole+fractional;

        var trailingZeroes = Number(exp[3]) - (digits.length - (whole.length));

        if(trailingZeroes > 0) {
          return digits + '0'.repeat(trailingZeroes);
        } else if(trailingZeroes < 0) {
          return digits.substring(0,digits.length+trailingZeroes) + '.' + digits.substring(digits.length+trailingZeroes);
        }
        return digits;
      }
      return number;
    },
    extractSign(numerator) {
      numerator = this.toNumberString(numerator);
      if(numerator.indexOf('-') == 0) {
        return {
          sign: '-',
          numerator: numerator.substring(1),
        };
      }
      return { numerator, sign: '' };
    },
    addDelimiter(number, delimiter=",", occurance=3) {
      if(typeof number == Number) number = String(number);
      return number.split("").reverse().reduce((num, digit, i) => {
        if (!i || i%occurance) {
          num.push(digit);
        } else {
          num = num.concat(delimiter, digit);
        }
        return num;
      }, []).reverse().join("");
    },
  },
  watch: {

  },
};

</script>
